local csock = csock
local ssock = nil

MCcmd = {}
dofile(P"cmds.lua")

-- Minecraft server packets
local MCtab = {}
MCtab["\0"] = 0
MCtab["\1"] = function()
   read32(csock)
   readppstring(csock)
   readppstring(csock)
   read32(csock)
   read32(csock)
   read8(csock)
end
MCtab["\2"] = function()
   local hash = readppstring(csock)
end
MCtab["\3"] = function()
   local Str = readppstring(csock, true)
   local str = Str:lower()
   local wut = str:match("^thundera[,:](.*)$")
   if not wut then
      wut = str:match("^>(.*)$")
   end
   if wut then
      messagef(">%s", wut)
      local arg = SC.ParseCommandLine(wut:gsub("[%.!%?]+$",""))
      local s,e = xpcall(function()
			    local cmd = table.remove(arg,1):lower()
			    if MCcmd[cmd] then
			       MCcmd[cmd](unpack(arg))
			    else messagef("unknown command: %s",cmd) end
			 end, debug.traceback)
      if not s then messagef("! %s", e) end
   else
      soft_send(_G.ssock, "\3"..makeppstring(Str))
   end
end
MCtab["\5"] = function()
   local type = read32(csock)
   local count = read16(csock)
   for n=1,count do
      local id = read16(csock)
      if id ~= -1 then
	 local count = read8(csock)
	 local health = read16(csock)
      end
   end
end
MCtab["\7"] = 9
MCtab["\10"] = 1
MCtab["\11"] = function()
   local x = readdbl(csock)
   local y = readdbl(csock)
   local stance = readdbl(csock)
   local z = readdbl(csock)
   local ground = read8(csock)
   player_x = x
   player_y = y
   player_z = z
   player_stance = stance
   player_ground = ground
end
MCtab["\12"] = function()
   local yaw = readflt(csock)
   local pitch = readflt(csock)
   local ground = read8(csock)
   player_yaw = yaw
   player_pitch = pitch
   player_ground = ground
end
MCtab["\13"] = function()
   local x = readdbl(csock)
   local y = readdbl(csock)
   local stance = readdbl(csock)
   local z = readdbl(csock)
   local yaw = readflt(csock)
   local pitch = readflt(csock)
   local ground = read8(csock)
   player_x = x
   player_y = y
   player_z = z
   player_stance = stance
   player_yaw = yaw
   player_pitch = pitch
   player_ground = ground
end
MCtab["\14"] = 11
MCtab["\15"] = 12
MCtab["\16"] = 6
MCtab["\18"] = 5
MCtab["\21"] = 22
MCtab["\27"] = 8 -- Solra-rev, questionable
MCtab["\38"] = 5 -- Solra-rev, questionable; entity-id + one byte
MCtab["\59"] = function()
   read32(csock)
   read16(csock)
   read32(csock)
   local len = read16(csock)
   soft_receive(csock, len)
end
MCtab["\255"] = function()
   local why = readppstring(csock)
   error("Client quit: "..why)
end

repeat
   local wut = soft_receive(csock, 1, true)
   if MCtab[wut] then
      if wut ~= "\3" then soft_send(_G.ssock, wut) end
      if type(MCtab[wut]) == "number" then
	 soft_receive(csock, MCtab[wut])
      else
	 MCtab[wut]()
      end
   else
      error("client sent unknown packet "..wut:byte())
   end
until false
error "end of execution"
