require "deflate"
local ssock = ssock
local csock = nil

messages = {}
function messagef(format,...)
   local color = "9"
   local text = format:format(...)
   if text:sub(1,1) == "!" then color,text = "c",text:gsub("\n","\n! ")
   elseif text:sub(1,1) == ">" then color = 1
   end
   for l in text:gmatch("[^\n]+") do
      messages[#messages+1] = "\194\167"..color..l:gsub("\t","    ")
   end
end

-- Minecraft server packets
local MCtab = {}
MCtab["\0"] = 0
MCtab["\1"] = function()
   read32(ssock)
   readppstring(ssock)
   readppstring(ssock)
   read32(ssock)
   read32(ssock)
   read8(ssock)
end
MCtab["\2"] = function()
   local hash = readppstring(ssock)
end
MCtab["\3"] = function()
   local str = readppstring(ssock)
end
MCtab["\4"] = 8
MCtab["\5"] = function()
   local type = read32(ssock)
   local count = read16(ssock)
   for n=1,count do
      local id = read16(ssock)
      if id ~= -1 then
	 local count = read8(ssock)
	 local health = read16(ssock)
      end
   end
end
MCtab["\6"] = 12
MCtab["\7"] = 8
MCtab["\8"] = 1 -- health!
MCtab["\13"] = function()
   local x = readdbl(ssock)
   local stance = readdbl(ssock)
   local y = readdbl(ssock)
   local z = readdbl(ssock)
   local yaw = readflt(ssock)
   local pitch = readflt(ssock)
   local ground = read8(ssock)
   player_x = x
   player_y = y
   player_z = z
   player_stance = stance
   player_yaw = yaw
   player_pitch = pitch
   player_ground = ground
end
MCtab["\16"] = 6
MCtab["\17"] = 5
MCtab["\18"] = 5
MCtab["\20"] = function()
   read32(ssock)
   local name = readppstring(ssock)
   -- do something with name?
   read32(ssock)
   read32(ssock)
   read32(ssock)
   read16(ssock)
   read16(ssock)
end
MCtab["\21"] = 22
MCtab["\22"] = 8
MCtab["\23"] = 17
MCtab["\24"] = 19
MCtab["\27"] = 8 -- Solra-rev, questionable
MCtab["\28"] = 10
MCtab["\29"] = 4
MCtab["\30"] = 4
MCtab["\31"] = 7
MCtab["\32"] = 6
MCtab["\33"] = 9
MCtab["\34"] = 18
MCtab["\38"] = 5 -- Solra-rev, questionable; entity-id + one byte
MCtab["\39"] = 8
MCtab["\50"] = function()
   local X,Y = read32(ssock),read32(ssock)
   local why = read8(ssock)
   if why == 0 then
      if not not_caring then
         edits[#edits+1] = {type="kill",X=X,Y=Y}
      end
   end
end
MCtab["\51"] = function()
   local x = read32(ssock)
   local y = read16(ssock)
   local z = read32(ssock)
   local sizex = read8(ssock)+1
   local sizey = read8(ssock)+1
   local sizez = read8(ssock)+1
   local len = read32(ssock, mode == "trans")
   local cdat = soft_receive(ssock, len, mode == "trans")
   local dat = deflate.decompress(cdat)
   if not not_caring then
      edits[#edits+1] = {type="bulk",x=x,y=y,z=z,sizex=sizex,sizey=sizey,sizez=sizez,dat=dat}
   end
   if mode == "trans" then
      dat= string.gsub(dat, ".", function(s)
            if trans_types[s] then
               return "\20" -- 20 is glass and we've decided to replace the listed things with glass.
            end
            return s -- Didn't match anything in list, leave it as-is.
         end)
      local rcdat= deflate.compress(dat)
      local rclen= #rcdat
      soft_send(other[ssock], make32(rclen))
      soft_send(other[ssock], rcdat)
   end
end
MCtab["\52"] = function()
   local X = read32(ssock)
   local Z = read32(ssock)
   local count = read16(ssock)
   local coords = {}
   local types = {}
   local datas = {}
   for n=1,count do
      coords[n] = read16(ssock)
      if coords[n] < 0 then coords[n] = coords[n] + 65536 end
   end
   for n=1,count do
      types[n] = read8(ssock)
   end
   for n=1,count do
      datas[n] = read8(ssock)
   end
   if not not_caring then
      edits[#edits+1] = {type="multi",coords=coords,types=types,datas=datas,X=X,Z=Z,count=count}
   end
end
MCtab["\53"] = function()
   local x = read32(ssock)
   local y = read8(ssock)
   local z = read32(ssock)
   local type = read8(ssock)
   local dat = read8(ssock)
   if not not_caring then
      edits[#edits+1] = {type="one",x=x,y=y,z=z,typ=type,dat=dat}
   end
end
MCtab["\59"] = function()
   read32(ssock)
   read16(ssock)
   read32(ssock)
   local len = read16(ssock)
   soft_receive(ssock, len)
end
MCtab["\60"] = function()
		  soft_receive(ssock,28)
		  local count = read32(ssock)
		  soft_receive(ssock,count*3)
		  end
MCtab["\255"] = function()
   local why = readppstring(ssock)
   error("Server kick: "..why)
end

repeat
   local wut = soft_receive(ssock, 1)
   if MCtab[wut] then
      if type(MCtab[wut]) == "number" then
	 soft_receive(ssock, MCtab[wut])
      else
	 MCtab[wut]()
      end
   else
      error("server sent unknown packet "..wut:byte())
   end
   while #messages > 0 do
      local message = table.remove(messages,1)
      soft_send(_G.csock, "\3"..makeppstring(message))
   end
until false
error "end of execution"
